/**
 * Copyright (C) 1999 ILX Systems.  All Rights Reserved.
 * File name: ILXQuoteCP.h CP proxy class for _IILXQuoteCtrlEvents interface
 * Created By: Andrey S. Koshelev
 * Created on 3/6/99 10:13:44 PM
 * Comments: ...
 *
 * $Log: ILXCommonEventProxy.h,v $
 * Revision 1.1  2004/09/07 06:10:49  me133
 * o Initial checkin to CVS
 *
 * 
 * 17    4/11/02 5:53p Marce
 * o Rolled back recent changes because it would cause some builds to fail
 * 
 * 15    4/11/02 5:18p Marce
 * o Added a define so that the ATL includes aren't included and _Module
 * isn't referenced.  This was causing a compile error when included by
 * ActiveILX.
 * 
 * 14    10/26/01 11:48a Alexm
 * 
 * 13    10/25/01 4:27p Marce
 * o Added OnContextChanged
 * 
 * 11    4/19/01 1:31p Billyr
 * 
 * 10    4/19/01 1:30p Billyr
 * 
 * 9     10/16/00 5:19p Youngh
 * Added OnSymListChange event.
 * 
 * 7     2/09/00 3:33p Alexanderk
 * 
 * 5     10/06/99 11:42a Rafaelc
 * Moved OnQuickQuote() from Monitor into ILX common events
 * 
 * 4     10/05/99 6:28p Youngh
 * Added OnNavigateURL() in ILX common events.
 * 
 * 3     9/20/99 3:40p Marce
 * o Added OnAlert()
 * 
 * 2     9/20/99 1:09p Marce
 * 
 * 1     9/16/99 4:36p Marce
 * 
 * 12    8/24/99 11:20a Marce
 * o Now uses long instead of enum
 * 
 * 11    7/23/99 6:22p Marce
 * o Should not fire OnAlert()
 * 
 * 10    7/23/99 4:22p Marce
 * o Fire_OnOnAlert() was not initializing the returned HRESULT
 * 
 * 9     7/23/99 3:16p Alexanderk
 * 
 * 8     7/21/99 3:21p Marce
 * o IlxCommon Connection status signatures changed
 * 
 * 7     6/24/99 5:07p Marce
 * o Changed ProgId and interface names from ILXQuoteCtrl to ILXQuote
 * 
 * 6     5/06/99 1:33p Marce
 * o Added AppFramework common properties: DisplayVScrollBar,
 * DisplayHScrollBar, InstanceName, and DataDirectory.  The properties are
 * programmatically accessable but they do nothing and there is no
 * property page for them.  This should be added soon.
 * o Changed OnSymbolChanged() signature and implementation to support
 * passing the symbol change source as an event parameter
 * 
 * 5     4/29/99 5:36p Marce
 * o Methods were returning an uninitialized scode value (0xcdcdcdcd)
 * 
 * 4     4/22/99 1:05p Marce
 * o Moved some stuff around to minimize compile-time dependencies and to
 * improve the organization of the code
 * 
 * 3     4/15/99 10:46a Marce
 * o Now uses ILX DISPIDs
 * 
 * 2     3/26/99 5:50p Andreyk
 * Added stuff for Right mouse button
 * 
 * 1     3/06/99 10:15p Andreyk
 * Created
 */

#ifndef INCLUDED_ILX_COMMON_EVENT_PROXY_H
#define INCLUDED_ILX_COMMON_EVENT_PROXY_H

#ifndef IGNORE_ATL_INCLUDES
#include <atldef.h>			// unicode
#include <wtypes.h>			// IID
#include <atlbase.h>		// Needed by atlcom.h
extern CComModule _Module;	// Needed by atlcom.h
#include <atlcom.h>			// IConnectionPointImpl
#endif // IGNORE_ATL_INCLUDES

#include <tchar.h>			// unicode

class CILXCommonEventProxy
{

public:
	CILXCommonEventProxy(	CComObjectRootEx<CComSingleThreadModel>* pIlxControl,
							CComDynamicUnkArray* pUnkArray);

	HRESULT Fire_OnDoubleLeftClick(LONG x, LONG y);
	HRESULT Fire_OnContextMenu(
		IDispatch* pTransferableProperties, 
		IDispatch * pSourceMenuInfo, 
		LONG x, LONG y);
	HRESULT Fire_OnSymbolChange(BSTR bstrSymbol, LONG ePropertyChangeSource);
	HRESULT Fire_OnILXError(VARIANT& varErrorObject);
	HRESULT Fire_OnAlert();
	HRESULT Fire_OnNavigateURL(BSTR bstrURL);
	HRESULT Fire_OnQuickQuote(BSTR pVal);
 	HRESULT Fire_OnDrillDown(
		long lDrillDownID,
		IDispatch* pTransferableProperties,
		BSTR bstrSourceName,
		BSTR bstrTargetName);
	HRESULT Fire_OnValidateLinks(IDispatch* pDrillDownLinks);
	HRESULT Fire_OnSymListChange(BSTR bstrSymList);

	HRESULT Fire_OnContextChanged(VARIANT varProps, VARIANT varReason);

protected:
	void lock();
	void unlock();
	long getTotalConnections() const;
	IUnknown* getConnection(long nIndex);

private:
	CComObjectRootEx<CComSingleThreadModel>* m_pIlxControl;
	CComDynamicUnkArray* m_pvec;
};

#endif // INCLUDED_ILX_COMMON_EVENT_PROXY_H