///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2000 ILX Systems.  All Rights Reserved.
//
//      $Header: /u/4/m/me133/cvs/Common/IlxDrillDownImpl.cpp,v 1.1 2004/09/07 06:10:50 me133 Exp $
//
//    File name:	IlxDrillDownImpl.cpp
//   Created By:	Marc Eaddy
//   Created On:	02/28/2002 4:50:52 PM
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: IlxDrillDownImpl.cpp,v $
 * Revision 1.1  2004/09/07 06:10:50  me133
 * o Initial checkin to CVS
 * 
 * 
 * 3     2/28/02 5:15p Marce
 * o Added some comments
 * o Made case consistent
 * 
 * 2     2/28/02 4:56p Marce
 * o Moved some implementation into CPP file
 */

#include "StdAfx.h"

#include "IlxDrillDownImpl.h"	// Me

//////////////////////////////
// ILX DRILL DOWN LINKS IMPL
//////////////////////////////

CIlxDrillDownLinks::CIlxDrillDownLinks()
{ }
	
CIlxDrillDownLinks::~CIlxDrillDownLinks()
{ }

STDMETHODIMP CIlxDrillDownLinks::Add(IDispatch* piLinkDisp)
{
	if (!piLinkDisp) return E_POINTER;

	m_coll.push_back(CComVariant(piLinkDisp));
	return S_OK;
}

STDMETHODIMP CIlxDrillDownLinks::Clear()
{
	m_coll.clear();
	return S_OK;
}

HRESULT CIlxDrillDownLinks::FindById(long nDrillDownId, IILXDrillDownLink2** ppiDrillDownLink2)
{
	HRESULT hr = S_OK;
	HRESULT hrRet = S_OK;

	_ASSERTE(ppiDrillDownLink2 && !*ppiDrillDownLink2);
	if (!ppiDrillDownLink2) return E_POINTER;
	if (*ppiDrillDownLink2) return E_INVALIDARG;

	// Initialize out parameters
	*ppiDrillDownLink2 = 0;

	for(CVariantVector::iterator it = m_coll.begin();
		it != m_coll.end(); 
		++it)
	{
		CComVariant& varElement = *it;
		_ASSERTE(varElement.vt == VT_DISPATCH || varElement.vt == VT_UNKNOWN);

		if (varElement.vt != VT_DISPATCH && varElement.vt != VT_UNKNOWN)
		{
			hrRet = FAILED(hrRet) ? hrRet : hr;
			continue;
		}

		CComPtr<IILXDrillDownLink2> spiDrillDownLink2;
		hr = varElement.punkVal->QueryInterface(	IID_IILXDrillDownLink2,
													(void**) &spiDrillDownLink2);
		if (FAILED(hr))
		{
			hrRet = FAILED(hrRet) ? hrRet : hr;
			continue;
		}

		if (!spiDrillDownLink2)
		{
			hrRet = FAILED(hrRet) ? hrRet : hr;
			continue;
		}

		long nCurrentDrillDownId = -1;
		hr = spiDrillDownLink2->get_ID(&nCurrentDrillDownId);
		if (FAILED(hr))
		{
			hrRet = FAILED(hrRet) ? hrRet : hr;
			continue;
		}

		if (nDrillDownId == nCurrentDrillDownId)
		{
			hr = spiDrillDownLink2.CopyTo(ppiDrillDownLink2);
			if (FAILED(hr))
			{
				hrRet = FAILED(hrRet) ? hrRet : hr;
			}

			break;
		}
	}

	return hrRet;
}
