///////////////////////////////////////////////////////////////////////
//  Copyright (C) 2004 Columbia University.  All Rights Reserved.
//
//      $Header: /Goblin/Patcher/ILHelper.h 2     5/28/05 1:20p Eaddy $
//
//    File name:	ILHelper.h
//   Created By:	Marc Eaddy
//   Created on:	10/10/04
//
//      Purpose:	
//
//  Description:	
//
///////////////////////////////////////////////////////////////////////
/**
 * $Log: /Goblin/Patcher/ILHelper.h $
 * 
 * 2     5/28/05 1:20p Eaddy
 * Changed copyright
 * Revision 1.4  2004/10/26 04:36:12  me133
 * no message
 *
 * Revision 1.3  2004/10/25 01:03:48  me133
 * o Method IL comparison is now complete and correct
 *
 * Revision 1.2  2004/10/10 06:07:45  me133
 * o Added header comment
 */

#ifndef INCLUDED_IL_HELPER_H
#define INCLUDED_IL_HELPER_H

#include <iterator>		// STL iterator<>

// Forward declarations
class CMethodInfo;

// Uses #include file magic to create array of opcodes

struct OPCODE_ENCODING
{
    BYTE OpCode1;
    BYTE OpCode2;
	ULONG Len;
	const char* szName;
};

#define OPDEF( id, name, pop, push, operand, type, len, OpCode1, OpCode2, cf ) { OpCode1, OpCode2, len, name },

// array of IL opcodes
const OPCODE_ENCODING g_ILcodes [] = 
{
#include "opcode.def"
};
#undef OPDEF

// Use #include file magic to create enumeration of opcodes

#define OPDEF( id, s, pop, push, args, type, l, OpCode1, OpCode2, ctrl ) id,
typedef enum enumOpcode
{
#include "opcode.def"
  CEE_COUNT,  /* number of instructions and macros pre-defined */
} OPCODE;
#undef OPDEF

// opcode_iterator

class opcode_iterator : public std::iterator<std::input_iterator_tag,
                                            LPBYTE>
{
public:

	opcode_iterator(LPBYTE pIPStart, 
					LPBYTE pIPEnd, 
					OPCODE opcode=CEE_COUNT);
    
	opcode_iterator(const CMethodInfo& methodInfo,
					OPCODE opcode=CEE_COUNT);

	opcode_iterator& operator++();
    LPBYTE operator*() const;
	bool end() const;

	bool isOpCodeEqual(OPCODE opcodeFirst, OPCODE opcodeSecond=CEE_COUNT) const;

	LPBYTE getOpCode() const;
	LPBYTE getOpCodeArg() const;

	// Returns true if there was an IL parse error, ie we encountered
	// an unknown opcode
	bool isError() const;

	// Performs a binary comparison of the current opcode and
	// its parameters
	friend bool InstructionsAreEqual(	const opcode_iterator& itLhs,
										const opcode_iterator& itRhs);

private: // NOT IMPLEMENTED
	opcode_iterator& operator=(const opcode_iterator& that);
	opcode_iterator(const opcode_iterator&);

private: // DATA
	LPBYTE m_pIPStart;
	LPBYTE m_pIPEnd;
	LPBYTE m_pIPCur;
	OPCODE m_opcode;
	HRESULT m_hrLast;
};

// Performs a binary comparison of the current opcode
bool OpcodesAreEqual(	const opcode_iterator& itLhs,
						const opcode_iterator& itRhs);

#endif // INCLUDED_IL_HELPER_H
