using System;

namespace MyAspectsNS
{
	class AspectContext
	{
		public string name;
	}

	class TraceAspect
	{
		void before(AspectContext context)
		{
			Console.WriteLine("Entering method 1 " + "context.name");
			Console.WriteLine("Entering method 2 " + "context.Name");
		}
		
		void after(AspectContext context)
		{
			Console.WriteLine("Leaving method 1");
			Console.WriteLine("Leaving method 2");
		}

		//void around(AspectContext context)
		//{
		//	Console.WriteLine("Replacing method 1");
		//	Console.WriteLine("Replacing method 1");
		//}
	}

	class CallStackAspect
	{
		HashTable threads;

		CallStackAspect()
		{
			threads = new HashTable();
		}

		ArrayList getThreadStack(long tid)
		{
			Object obj = threads[tid];
			if (obj == null)
			{
				obj = new ArrayList();
				threads[tid] = obj;
			}

			return obj as ArrayList;

		}

		void before(AspectContext context)
		{
			getThreadStack(Threading.GetCurrentThreadId()).push(context.name);
		}
		
		void after(AspectContext context)
		{
			getThreadStack(Threading.GetCurrentThreadId()).pop();
		}
	}
}